import _ from "node:path";
import { ESLintUtils as ue, ASTUtils as W } from "@typescript-eslint/utils";
import { minimatch as D } from "minimatch";
import ce from "natural-compare-lite";
import { builtinModules as de } from "node:module";
let I = ue.RuleCreator(
  (r) => `https://eslint-plugin-perfectionist.azat.io/rules/${r}`
), x = (r, l) => {
  for (let s = 0, t = r.length; s < t; s++) {
    let c = r[s];
    if (l.group === c || Array.isArray(c) && typeof l.group == "string" && c.includes(l.group))
      return s;
  }
  return r.length;
}, j = (r) => {
  let [l, s] = r;
  return s - l;
}, k = (r) => r > 0;
var p = /* @__PURE__ */ ((r) => (r.alphabetical = "alphabetical", r["line-length"] = "line-length", r.natural = "natural", r))(p || {}), d = /* @__PURE__ */ ((r) => (r.desc = "desc", r.asc = "asc", r))(d || {});
let R = (r) => {
  let l, s = (c) => {
    !l && r.flat().includes(c) && (l = c);
  };
  return {
    getGroup: () => l ?? "unknown",
    setCustomGroups: (c, a) => {
      if (c)
        for (let [e, n] of Object.entries(c))
          Array.isArray(n) && n.some(
            (i) => D(a, i, {
              nocomment: !0
            })
          ) && s(e), typeof n == "string" && D(a, n, {
            nocomment: !0
          }) && s(e);
    },
    defineGroup: s
  };
}, O = (r, l, s) => {
  var e, n;
  if ((e = l.dependencies) != null && e.includes(r.name))
    return -1;
  if ((n = r.dependencies) != null && n.includes(l.name))
    return 1;
  let t = s.order === "asc" ? 1 : -1, c, a = (i) => s["ignore-case"] ? i.toLowerCase() : i;
  return s.type === p.alphabetical ? c = (i, o) => a(i.name).localeCompare(a(o.name)) : s.type === p.natural ? c = (i, o) => ce(a(i.name), a(o.name)) : c = (i, o) => {
    let u = i.size, y = o.size, h = s["max-line-length"];
    if (h) {
      let f = (g, m) => g > h && m.hasMultipleImportDeclarations;
      f(u, i) && (u = i.name.length + 10), f(y, o) && (y = o.name.length + 10);
    }
    return u - y;
  }, t * c(r, l);
}, A = (r, l) => [...r].sort((s, t) => O(s, t, l)), fe = (r, l) => {
  let s = l.getTokenAfter(r, {
    filter: ({ value: t, type: c }) => !(c === "Punctuator" && [",", ";"].includes(t)),
    includeComments: !0
  });
  return ((s == null ? void 0 : s.type) === "Block" || (s == null ? void 0 : s.type) === "Line") && r.loc.end.line === s.loc.end.line ? s : null;
}, pe = (r, l) => Array.isArray(r) && r.some(
  (s) => D(l.trim(), s, {
    nocomment: !0
  })
) || typeof r == "string" && D(l.trim(), r, {
  nocomment: !0
}) || r === !0, J = (r, l) => {
  let [s, t] = l.getTokensBefore(r, {
    filter: ({ value: c, type: a }) => !(a === "Punctuator" && [",", ";"].includes(c)),
    includeComments: !0,
    count: 2
  });
  return ((t == null ? void 0 : t.type) === "Block" || (t == null ? void 0 : t.type) === "Line") && r.loc.start.line - t.loc.end.line <= 1 && (s == null ? void 0 : s.loc.end.line) !== t.loc.start.line ? t : null;
}, M = (r, l, s) => {
  var n;
  let t = r.range.at(0), c = r.range.at(1), a = l.text.slice(t, c);
  if (W.isParenthesized(r, l)) {
    let i = l.getTokenBefore(
      r,
      W.isOpeningParenToken
    ), o = l.getTokenAfter(
      r,
      W.isClosingParenToken
    );
    t = i.range.at(0), c = o.range.at(1);
  }
  let e = J(r, l);
  if (a.endsWith(";") || a.endsWith(",")) {
    let i = l.getTokensAfter(r, {
      includeComments: !0,
      count: 2
    });
    r.loc.start.line === ((n = i.at(1)) == null ? void 0 : n.loc.start.line) && (c -= 1);
  }
  return e && !pe(
    (s == null ? void 0 : s.partitionComment) ?? !1,
    e.value
  ) && (t = e.range.at(0)), [t, c];
}, T = (r, l, s, t, c) => {
  var n, i;
  let a = [], e = ((n = l.at(0)) == null ? void 0 : n.node.loc.start.line) === ((i = l.at(-1)) == null ? void 0 : i.node.loc.end.line);
  for (let o = 0, u = l.length; o < u; o++) {
    let { node: y } = l.at(o);
    a.push(
      r.replaceTextRange(
        M(y, t, c),
        t.text.slice(
          ...M(s.at(o).node, t, c)
        )
      )
    );
    let h = fe(s.at(o).node, t);
    if (h && !e) {
      let g = [
        t.getTokenBefore(h).range.at(1),
        h.range.at(1)
      ];
      a.push(r.replaceTextRange(g, ""));
      let m = t.getTokenAfter(y);
      a.push(
        r.insertTextAfter(
          (m == null ? void 0 : m.loc.end.line) === y.loc.end.line ? m : y,
          t.text.slice(...g)
        )
      );
    }
  }
  return a;
}, C = (r = {}, l) => Object.assign(l, r), P = (r, l) => {
  if (r.length > 1)
    for (let s = 1; s < r.length; s++) {
      let t = r.at(s - 1), c = r.at(s);
      t && c && l(t, c, s - 1);
    }
};
const X = "sort-svelte-attributes", ge = I({
  name: X,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Svelte attributes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedSvelteAttributesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => _.extname(r.getFilename()) !== ".svelte" ? {} : {
    SvelteStartTag: (l) => {
      if (l.attributes.length > 1) {
        let s = C(r.options.at(0), {
          type: p.alphabetical,
          order: d.asc,
          "ignore-case": !1,
          "custom-groups": {},
          groups: []
        }), t = r.getSourceCode(), c = l.attributes.reduce(
          (a, e) => {
            if (e.type === "SvelteSpreadAttribute")
              return a.push([]), a;
            let n, { getGroup: i, defineGroup: o, setCustomGroups: u } = R(
              s.groups
            );
            return e.key.type === "SvelteSpecialDirectiveKey" ? n = t.text.slice(...e.key.range) : typeof e.key.name == "string" ? { name: n } = e.key : n = t.text.slice(...e.key.range), u(s["custom-groups"], n), e.type === "SvelteShorthandAttribute" && (o("svelte-shorthand"), o("shorthand")), (!("value" in e) || Array.isArray(e.value) && !e.value.at(0)) && o("shorthand"), e.loc.start.line !== e.loc.end.line && o("multiline"), a.at(-1).push({
              size: j(e.range),
              node: e,
              group: i(),
              name: n
            }), a;
          },
          [[]]
        );
        for (let a of c)
          P(a, (e, n) => {
            let i = x(s.groups, e), o = x(s.groups, n);
            (i > o || i === o && k(O(e, n, s))) && r.report({
              messageId: "unexpectedSvelteAttributesOrder",
              data: {
                left: e.name,
                right: n.name
              },
              node: n.node,
              fix: (u) => {
                let y = {};
                for (let f of a) {
                  let g = x(s.groups, f);
                  g in y ? y[g] = A(
                    [...y[g], f],
                    s
                  ) : y[g] = [f];
                }
                let h = [];
                for (let f of Object.keys(y).sort())
                  h.push(...A(y[f], s));
                return T(u, a, h, t);
              }
            });
          });
      }
    }
  }
}), q = "sort-astro-attributes", ye = I({
  name: q,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Astro attributes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedAstroAttributesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  // @ts-ignore
  create: (r) => _.extname(r.getFilename()) !== ".astro" ? {} : {
    JSXElement: (l) => {
      let { attributes: s } = l.openingElement;
      if (s.length > 1) {
        let t = C(r.options.at(0), {
          type: p.alphabetical,
          order: d.asc,
          "ignore-case": !1,
          "custom-groups": {},
          groups: []
        }), c = r.getSourceCode(), a = s.reduce(
          (e, n) => {
            if (n.type === "JSXSpreadAttribute")
              return e.push([]), e;
            let i = typeof n.name.name == "string" ? n.name.name : c.text.slice(...n.name.range), { getGroup: o, defineGroup: u, setCustomGroups: y } = R(
              t.groups
            );
            return y(t["custom-groups"], i), n.type === "AstroShorthandAttribute" && (u("astro-shorthand"), u("shorthand")), n.value === null && u("shorthand"), n.loc.start.line !== n.loc.end.line && u("multiline"), e.at(-1).push({
              size: j(n.range),
              node: n,
              group: o(),
              name: i
            }), e;
          },
          [[]]
        );
        for (let e of a)
          P(e, (n, i) => {
            let o = x(t.groups, n), u = x(t.groups, i);
            (o > u || o === u && k(O(n, i, t))) && r.report({
              messageId: "unexpectedAstroAttributesOrder",
              data: {
                left: n.name,
                right: i.name
              },
              node: i.node,
              fix: (y) => {
                let h = {};
                for (let g of e) {
                  let m = x(t.groups, g);
                  m in h ? h[m] = A(
                    [...h[m], g],
                    t
                  ) : h[m] = [g];
                }
                let f = [];
                for (let g of Object.keys(h).sort())
                  f.push(...A(h[g], t));
                return T(y, e, f, c);
              }
            });
          });
      }
    }
  }
});
let v = (r) => r.replaceAll(/\s\s+/g, " ").trim();
const K = "sort-array-includes", me = I({
  name: K,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted arrays before include method"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "spread-last": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedArrayIncludesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    MemberExpression: (l) => {
      if ((l.object.type === "ArrayExpression" || l.object.type === "NewExpression") && l.property.type === "Identifier" && l.property.name === "includes") {
        let s = l.object.type === "ArrayExpression" ? l.object.elements : l.object.arguments;
        if (s.length > 1) {
          let t = C(r.options.at(0), {
            type: p.alphabetical,
            order: d.asc,
            "ignore-case": !1,
            "spread-last": !1
          }), c = r.getSourceCode(), a = s.reduce(
            (e, n) => (n !== null && e.at(0).push({
              name: n.type === "Literal" ? `${n.value}` : c.text.slice(...n.range),
              size: j(n.range),
              type: n.type,
              node: n
            }), e),
            [[], []]
          ).flat();
          P(a, (e, n) => {
            let i;
            t["spread-last"] && e.node.type === "Literal" && n.node.type === "SpreadElement" ? i = !1 : t["spread-last"] && e.node.type === "SpreadElement" && n.node.type === "Literal" ? i = !0 : i = k(O(e, n, t)), i && r.report({
              messageId: "unexpectedArrayIncludesOrder",
              data: {
                left: v(e.name),
                right: v(n.name)
              },
              node: n.node,
              fix: (o) => {
                let u = A(a, t);
                if (t["spread-last"])
                  for (let y = 0, h = u.length; y < h; y++)
                    u.at(y).node.type === "SpreadElement" && u.push(u.splice(y, 1).at(0));
                return T(o, a, u, c);
              }
            });
          });
        }
      }
    }
  })
}), F = "sort-vue-attributes", he = I({
  name: F,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Vue attributes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array",
            default: []
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedVueAttributesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => {
    if (_.extname(r.getFilename()) !== ".vue")
      return {};
    if (!("defineTemplateBodyVisitor" in r.parserServices))
      return {};
    let { defineTemplateBodyVisitor: l } = r.parserServices;
    return l({
      VStartTag: (s) => {
        if (s.attributes.length > 1) {
          let t = C(r.options.at(0), {
            type: p.alphabetical,
            order: d.asc,
            "ignore-case": !1,
            "custom-groups": {},
            groups: []
          }), c = r.getSourceCode(), a = s.attributes.reduce(
            (e, n) => {
              if (n.key.type === "VDirectiveKey" && n.key.name.rawName === "bind")
                return e.push([]), e;
              let i, { getGroup: o, defineGroup: u, setCustomGroups: y } = R(
                t.groups
              );
              return typeof n.key.name == "string" && n.key.type !== "VDirectiveKey" ? i = n.key.rawName : i = c.text.slice(...n.key.range), y(t["custom-groups"], i), n.value === null && u("shorthand"), n.loc.start.line !== n.loc.end.line && u("multiline"), e.at(-1).push({
                size: j(n.range),
                node: n,
                group: o(),
                name: i
              }), e;
            },
            [[]]
          );
          for (let e of a)
            P(e, (n, i) => {
              let o = x(t.groups, n), u = x(t.groups, i);
              (o > u || o === u && k(O(n, i, t))) && r.report({
                messageId: "unexpectedVueAttributesOrder",
                data: {
                  left: n.name,
                  right: i.name
                },
                node: i.node,
                fix: (y) => {
                  let h = {};
                  for (let g of e) {
                    let m = x(t.groups, g);
                    m in h ? h[m] = A(
                      [...h[m], g],
                      t
                    ) : h[m] = [g];
                  }
                  let f = [];
                  for (let g of Object.keys(h).sort())
                    f.push(...A(h[g], t));
                  return T(y, e, f, c);
                }
              });
            });
        }
      }
    });
  }
}), H = "sort-named-exports", be = I({
  name: H,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted named exports"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedNamedExportsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    ExportNamedDeclaration: (l) => {
      if (l.specifiers.length > 1) {
        let s = C(r.options.at(0), {
          type: p.alphabetical,
          "ignore-case": !1,
          order: d.asc
        }), t = r.getSourceCode(), c = l.specifiers.map((a) => ({
          size: j(a.range),
          name: a.local.name,
          node: a
        }));
        P(c, (a, e) => {
          k(O(a, e, s)) && r.report({
            messageId: "unexpectedNamedExportsOrder",
            data: {
              left: a.name,
              right: e.name
            },
            node: e.node,
            fix: (n) => T(n, c, A(c, s), t)
          });
        });
      }
    }
  })
}), Q = "sort-named-imports", xe = I({
  name: Q,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted named imports"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "ignore-alias": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedNamedImportsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    ImportDeclaration: (l) => {
      let s = l.specifiers.filter(
        ({ type: t }) => t === "ImportSpecifier"
      );
      if (s.length > 1) {
        let t = C(r.options.at(0), {
          type: p.alphabetical,
          "ignore-alias": !0,
          "ignore-case": !1,
          order: d.asc
        }), c = r.getSourceCode(), a = s.map((e) => {
          let { name: n } = e.local;
          return t["ignore-alias"] && e.type === "ImportSpecifier" && ({ name: n } = e.imported), {
            size: j(e.range),
            node: e,
            name: n
          };
        });
        P(a, (e, n) => {
          k(O(e, n, t)) && r.report({
            messageId: "unexpectedNamedImportsOrder",
            data: {
              left: e.name,
              right: n.name
            },
            node: n.node,
            fix: (i) => T(i, a, A(a, t), c)
          });
        });
      }
    }
  })
});
let B = (r, l, s) => r.lines.slice(
  l.node.loc.end.line,
  s.node.loc.start.line - 1
).filter((c) => !c.trim().length).length;
const Y = "sort-object-types", Ee = I({
  name: Y,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted object types"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array",
            default: []
          },
          "partition-by-new-line": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedObjectTypesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    TSTypeLiteral: (l) => {
      if (l.members.length > 1) {
        let s = C(r.options.at(0), {
          "partition-by-new-line": !1,
          type: p.alphabetical,
          "ignore-case": !1,
          order: d.asc,
          "custom-groups": {},
          groups: []
        }), t = r.getSourceCode(), c = l.members.reduce(
          (a, e) => {
            var E, b, N, S;
            let n, i = t.text.slice(e.range.at(0), e.range.at(1)), o = (E = a.at(-1)) == null ? void 0 : E.at(-1), { getGroup: u, defineGroup: y, setCustomGroups: h } = R(
              s.groups
            ), f = (L) => L.replace(/(,|;)$/, "");
            if (e.type === "TSPropertySignature")
              e.key.type === "Identifier" ? { name: n } = e.key : e.key.type === "Literal" ? n = `${e.key.value}` : n = t.text.slice(
                e.range.at(0),
                (b = e.typeAnnotation) == null ? void 0 : b.range.at(0)
              );
            else if (e.type === "TSIndexSignature") {
              let L = ((N = e.typeAnnotation) == null ? void 0 : N.range.at(0)) ?? e.range.at(1);
              n = f(t.text.slice(e.range.at(0), L));
            } else
              n = f(
                t.text.slice(e.range.at(0), e.range.at(1))
              );
            h(s["custom-groups"], n), e.loc.start.line !== e.loc.end.line && y("multiline");
            let m = i.endsWith(";") || i.endsWith(",") ? 1 : 0, w = {
              size: j(e.range) - m,
              node: e,
              name: n
            };
            return s["partition-by-new-line"] && o && B(t, o, w) && a.push([]), (S = a.at(-1)) == null || S.push({
              ...w,
              group: u()
            }), a;
          },
          [[]]
        );
        for (let a of c)
          P(a, (e, n) => {
            let i = x(s.groups, e), o = x(s.groups, n);
            (i > o || i === o && k(O(e, n, s))) && r.report({
              messageId: "unexpectedObjectTypesOrder",
              data: {
                left: v(e.name),
                right: v(n.name)
              },
              node: n.node,
              fix: (u) => {
                let y = {};
                for (let f of a) {
                  let g = x(s.groups, f);
                  g in y ? y[g] = A(
                    [...y[g], f],
                    s
                  ) : y[g] = [f];
                }
                let h = [];
                for (let f of Object.keys(y).sort())
                  h.push(...A(y[f], s));
                return T(u, a, h, t);
              }
            });
          });
      }
    }
  })
}), Z = "sort-union-types", Se = I({
  name: Z,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted union types"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "nullable-last": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedUnionTypesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    TSUnionType: (l) => {
      let s = r.getSourceCode(), t = C(r.options.at(0), {
        type: p.alphabetical,
        "nullable-last": !1,
        "ignore-case": !1,
        order: d.asc
      }), c = l.types.map((a) => ({
        group: a.type === "TSNullKeyword" || a.type === "TSUndefinedKeyword" ? "nullable" : "unknown",
        name: s.text.slice(...a.range),
        size: j(a.range),
        node: a
      }));
      P(c, (a, e) => {
        let n = k(O(a, e, t));
        t["nullable-last"] && (a.group === "nullable" && e.group === "unknown" ? n = !0 : a.group === "unknown" && e.group === "nullable" && (n = !1)), n && r.report({
          messageId: "unexpectedUnionTypesOrder",
          data: {
            left: v(a.name),
            right: v(e.name)
          },
          node: e.node,
          fix: (i) => {
            let o = [];
            if (t["nullable-last"]) {
              let u = [], y = c.filter((h) => h.group === "nullable" ? (u.push(h), !1) : !0);
              o = [
                ...A(y, t),
                ...A(u, t)
              ];
            } else
              o = A(c, t);
            return T(i, c, o, s);
          }
        });
      });
    }
  })
}), ee = "sort-interfaces", we = I({
  name: ee,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted interface properties"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "ignore-pattern": {
            items: {
              type: "string"
            },
            type: "array"
          },
          groups: {
            type: "array",
            default: []
          },
          "partition-by-new-line": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedInterfacePropertiesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    TSInterfaceDeclaration: (l) => {
      if (l.body.body.length > 1) {
        let s = C(r.options.at(0), {
          "partition-by-new-line": !1,
          type: p.alphabetical,
          "ignore-case": !1,
          order: d.asc,
          "ignore-pattern": [],
          "custom-groups": {},
          groups: []
        });
        if (!s["ignore-pattern"].some(
          (t) => D(l.id.name, t, {
            nocomment: !0
          })
        )) {
          let t = r.getSourceCode(), c = l.body.body.reduce(
            (a, e) => {
              var f, g, m, w;
              if (e.type === "TSCallSignatureDeclaration")
                return a.push([]), a;
              let n = (f = a.at(-1)) == null ? void 0 : f.at(-1), i, { getGroup: o, defineGroup: u, setCustomGroups: y } = R(
                s.groups
              );
              if (e.type === "TSPropertySignature")
                if (e.key.type === "Identifier")
                  ({ name: i } = e.key);
                else if (e.key.type === "Literal")
                  i = `${e.key.value}`;
                else {
                  let E = ((g = e.typeAnnotation) == null ? void 0 : g.range.at(0)) ?? e.range.at(1) - (e.optional ? 1 : 0);
                  i = t.text.slice(e.range.at(0), E);
                }
              else if (e.type === "TSIndexSignature") {
                let E = ((m = e.typeAnnotation) == null ? void 0 : m.range.at(0)) ?? e.range.at(1);
                i = t.text.slice(e.range.at(0), E);
              } else {
                let E = ((w = e.returnType) == null ? void 0 : w.range.at(0)) ?? e.range.at(1);
                i = t.text.slice(e.range.at(0), E);
              }
              let h = {
                size: j(e.range),
                node: e,
                name: i
              };
              return s["partition-by-new-line"] && n && B(t, n, h) && a.push([]), y(s["custom-groups"], i), e.loc.start.line !== e.loc.end.line && u("multiline"), a.at(-1).push({
                ...h,
                group: o()
              }), a;
            },
            [[]]
          );
          for (let a of c)
            P(a, (e, n) => {
              let i = x(s.groups, e), o = x(s.groups, n);
              (i > o || i === o && k(O(e, n, s))) && r.report({
                messageId: "unexpectedInterfacePropertiesOrder",
                data: {
                  left: v(e.name),
                  right: v(n.name)
                },
                node: n.node,
                fix: (u) => {
                  let y = {};
                  for (let f of a) {
                    let g = x(s.groups, f);
                    g in y ? y[g] = A(
                      [...y[g], f],
                      s
                    ) : y[g] = [f];
                  }
                  let h = [];
                  for (let f of Object.keys(y).sort())
                    h.push(...A(y[f], s));
                  return T(u, a, h, t);
                }
              });
            });
        }
      }
    }
  })
}), te = "sort-jsx-props", Ae = I({
  name: te,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted JSX props"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          groups: {
            type: "array"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedJSXPropsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => [".svelte", ".astro", ".vue"].includes(
    _.extname(r.getFilename())
  ) ? {} : {
    JSXElement: (l) => {
      if (l.openingElement.attributes.length > 1) {
        let s = C(r.options.at(0), {
          type: p.alphabetical,
          "ignore-case": !1,
          order: d.asc,
          "custom-groups": {},
          groups: []
        }), t = r.getSourceCode(), c = l.openingElement.attributes.reduce(
          (a, e) => {
            if (e.type === "JSXSpreadAttribute")
              return a.push([]), a;
            let n = e.name.type === "JSXNamespacedName" ? `${e.name.namespace.name}:${e.name.name.name}` : e.name.name, { getGroup: i, defineGroup: o, setCustomGroups: u } = R(
              s.groups
            );
            u(s["custom-groups"], n), e.value === null && o("shorthand"), e.loc.start.line !== e.loc.end.line && o("multiline");
            let y = {
              size: j(e.range),
              group: i(),
              node: e,
              name: n
            };
            return a.at(-1).push(y), a;
          },
          [[]]
        );
        for (let a of c)
          P(a, (e, n) => {
            let i = x(s.groups, e), o = x(s.groups, n);
            (i > o || i === o && k(O(e, n, s))) && r.report({
              messageId: "unexpectedJSXPropsOrder",
              data: {
                left: e.name,
                right: n.name
              },
              node: n.node,
              fix: (u) => {
                let y = {};
                for (let f of a) {
                  let g = x(s.groups, f);
                  g in y ? y[g] = A(
                    [...y[g], f],
                    s
                  ) : y[g] = [f];
                }
                let h = [];
                for (let f of Object.keys(y).sort())
                  h.push(...A(y[f], s));
                return T(u, a, h, t);
              }
            });
          });
      }
    }
  }
}), re = "sort-exports", Ne = I({
  name: re,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted exports"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedExportsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => {
    let l = C(r.options.at(0), {
      type: p.alphabetical,
      order: d.asc,
      "ignore-case": !1
    }), s = [[]], t = (c) => {
      c.type === "ExportAllDeclaration" && c.exported === null ? s.push([]) : s.at(-1).push({
        size: j(c.range),
        name: c.source.value,
        node: c
      });
    };
    return {
      ExportAllDeclaration: t,
      ExportNamedDeclaration: (c) => {
        c.source !== null && t(c);
      },
      "Program:exit": () => {
        let c = r.getSourceCode();
        for (let a of s)
          P(a, (e, n) => {
            k(O(e, n, l)) && r.report({
              messageId: "unexpectedExportsOrder",
              data: {
                left: e.name,
                right: n.name
              },
              node: n.node,
              fix: (i) => T(i, a, A(a, l), c)
            });
          });
      }
    };
  }
}), se = "sort-imports", Oe = I({
  name: se,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted imports"
    },
    fixable: "code",
    schema: [
      {
        id: "sort-imports",
        type: "object",
        properties: {
          "custom-groups": {
            type: "object",
            properties: {
              type: {
                type: "object"
              },
              value: {
                type: "object"
              }
            },
            additionalProperties: !1
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array",
            default: []
          },
          "internal-pattern": {
            items: {
              type: "string"
            },
            type: "array"
          },
          "newlines-between": {
            enum: [
              "ignore",
              "always",
              "never"
              /* never */
            ],
            default: "always",
            type: "string"
          },
          "max-line-length": {
            type: "integer",
            minimum: 0,
            exclusiveMinimum: !0
          }
        },
        allOf: [
          { $ref: "#/definitions/max-line-length-requires-line-length-type" }
        ],
        additionalProperties: !1,
        dependencies: {
          "max-line-length": ["type"]
        },
        definitions: {
          "is-line-length": {
            properties: {
              type: { enum: [p["line-length"]], type: "string" }
            },
            required: ["type"],
            type: "object"
          },
          "max-line-length-requires-line-length-type": {
            anyOf: [
              {
                not: { required: ["max-line-length"], type: "object" },
                type: "object"
              },
              { $ref: "#/definitions/is-line-length" }
            ]
          }
        }
      }
    ],
    messages: {
      unexpectedImportsOrder: 'Expected "{{right}}" to come before "{{left}}"',
      missedSpacingBetweenImports: 'Missed spacing between "{{left}}" and "{{right}}" imports',
      extraSpacingBetweenImports: 'Extra spacing between "{{left}}" and "{{right}}" imports'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => {
    let l = C(r.options.at(0), {
      "newlines-between": "always",
      "custom-groups": { type: {}, value: {} },
      "internal-pattern": ["~/**"],
      type: p.alphabetical,
      order: d.asc,
      "ignore-case": !1,
      groups: []
    }), s = !1;
    for (let o of l.groups)
      if (Array.isArray(o))
        for (let u of o)
          u === "unknown" && (s = !0);
      else
        o === "unknown" && (s = !0);
    s || (l.groups = [...l.groups, "unknown"]);
    let t = r.getSourceCode(), c = [], a = (o) => o.type === "ImportDeclaration" && o.specifiers.length === 0, e = (o) => {
      let u = (S) => [".less", ".scss", ".sass", ".styl", ".pcss", ".css", ".sss"].some(
        (L) => S.endsWith(L)
      ), y = (S) => [
        "./index.d.js",
        "./index.d.ts",
        "./index.js",
        "./index.ts",
        "./index",
        "./",
        "."
      ].includes(S), h = (S) => S.indexOf("..") === 0, f = (S) => S.indexOf("./") === 0, { getGroup: g, defineGroup: m, setCustomGroups: w } = R(l.groups), E = (S) => l["internal-pattern"].length && l["internal-pattern"].some(
        (L) => D(S.source.value, L, {
          nocomment: !0
        })
      ), b = (S) => {
        let L = [
          "bun",
          "bun:ffi",
          "bun:jsc",
          "bun:sqlite",
          "bun:test",
          "bun:wrap",
          "detect-libc",
          "undici",
          "ws"
        ];
        return de.includes(
          S.startsWith("node:") ? S.split("node:")[1] : S
        ) || L.includes(S);
      }, N = (S) => !(S.startsWith(".") || S.startsWith("/"));
      return o.importKind === "type" && (o.type === "ImportDeclaration" && (w(l["custom-groups"].type, o.source.value), y(o.source.value) && m("index-type"), f(o.source.value) && m("sibling-type"), h(o.source.value) && m("parent-type"), E(o) && m("internal-type"), b(o.source.value) && m("builtin-type"), N(o.source.value) && m("external-type")), m("type")), o.type === "ImportDeclaration" && (w(l["custom-groups"].value, o.source.value), a(o) && u(o.source.value) && m("side-effect-style"), a(o) && m("side-effect"), u(o.source.value) && m("style"), y(o.source.value) && m("index"), f(o.source.value) && m("sibling"), h(o.source.value) && m("parent"), E(o) && m("internal"), b(o.source.value) && m("builtin"), N(o.source.value) && m("external")), g();
    }, n = (o) => o.specifiers.length > 1, i = (o) => {
      let u;
      o.type === "ImportDeclaration" ? u = o.source.value : o.moduleReference.type === "TSExternalModuleReference" && o.moduleReference.expression.type === "Literal" ? u = `${o.moduleReference.expression.value}` : u = t.text.slice(...o.moduleReference.range), c.push({
        size: j(o.range),
        group: e(o),
        name: u,
        node: o,
        ...l.type === p["line-length"] && l["max-line-length"] && {
          hasMultipleImportDeclarations: n(
            o
          )
        }
      });
    };
    return {
      TSImportEqualsDeclaration: i,
      ImportDeclaration: i,
      "Program:exit": () => {
        var h;
        let o = (f, g) => !!t.getTokensBetween(
          f.node,
          J(g.node, t) || g.node,
          {
            includeComments: !0
          }
        ).length, u = (f, g) => {
          let m = [], w = {};
          for (let b of g) {
            let N = x(l.groups, b);
            N in w ? w[N] = A(
              [...w[N], b],
              l
            ) : w[N] = [b];
          }
          let E = Object.keys(w).sort().reduce(
            (b, N) => [
              ...b,
              ...w[N]
            ],
            []
          );
          for (let b = 0, N = E.length; b < N; b++) {
            let S = E.at(b);
            if (m.push(
              f.replaceTextRange(
                M(g.at(b).node, t),
                t.text.slice(...M(S.node, t))
              )
            ), l["newlines-between"] !== "ignore") {
              let L = E.at(b + 1);
              if (L) {
                let G = B(
                  t,
                  g.at(b),
                  g.at(b + 1)
                );
                (l["newlines-between"] === "always" && x(l.groups, S) === x(l.groups, L) && G !== 0 || l["newlines-between"] === "never" && G > 0) && m.push(
                  f.removeRange([
                    M(g.at(b).node, t).at(1),
                    M(g.at(b + 1).node, t).at(0) - 1
                  ])
                ), l["newlines-between"] === "always" && x(l.groups, S) !== x(l.groups, L) && G > 1 && m.push(
                  f.replaceTextRange(
                    [
                      M(g.at(b).node, t).at(1),
                      M(g.at(b + 1).node, t).at(
                        0
                      ) - 1
                    ],
                    `
`
                  )
                ), l["newlines-between"] === "always" && x(l.groups, S) !== x(l.groups, L) && G === 0 && m.push(
                  f.insertTextAfterRange(
                    M(g.at(b).node, t),
                    `
`
                  )
                );
              }
            }
          }
          return m;
        }, y = [[]];
        for (let f of c) {
          let g = (h = y.at(-1)) == null ? void 0 : h.at(-1);
          g && o(g, f) ? y.push([f]) : y.at(-1).push(f);
        }
        for (let f of y)
          P(f, (g, m) => {
            let w = x(l.groups, g), E = x(l.groups, m), b = B(t, g, m);
            !(a(g.node) && a(m.node)) && !o(g, m) && (w > E || w === E && k(O(g, m, l))) && r.report({
              messageId: "unexpectedImportsOrder",
              data: {
                left: g.name,
                right: m.name
              },
              node: m.node,
              fix: (N) => u(N, f)
            }), l["newlines-between"] === "never" && b > 0 && r.report({
              messageId: "extraSpacingBetweenImports",
              data: {
                left: g.name,
                right: m.name
              },
              node: m.node,
              fix: (N) => u(N, f)
            }), l["newlines-between"] === "always" && (w < E && b === 0 ? r.report({
              messageId: "missedSpacingBetweenImports",
              data: {
                left: g.name,
                right: m.name
              },
              node: m.node,
              fix: (N) => u(N, f)
            }) : (b > 1 || w === E && b > 0) && r.report({
              messageId: "extraSpacingBetweenImports",
              data: {
                left: g.name,
                right: m.name
              },
              node: m.node,
              fix: (N) => u(N, f)
            }));
          });
      }
    };
  }
}), ae = "sort-objects", ve = I({
  name: ae,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted objects"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          "partition-by-comment": {
            type: ["boolean", "string", "array"],
            default: !1
          },
          "partition-by-new-line": {
            type: "boolean",
            default: !1
          },
          "styled-components": {
            type: "boolean",
            default: !0
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedObjectsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => {
    let l = (s) => {
      if (s.properties.length > 1) {
        let t = C(r.options.at(0), {
          "partition-by-new-line": !1,
          "partition-by-comment": !1,
          type: p.alphabetical,
          "styled-components": !0,
          "ignore-case": !1,
          order: d.asc,
          "custom-groups": {},
          groups: []
        }), c = (i) => i.type === "Identifier" && i.name === "styled", a = (i) => i !== void 0 && i.type === "CallExpression" && (i.callee.type === "MemberExpression" && c(i.callee.object) || i.callee.type === "CallExpression" && c(i.callee.callee));
        if (!t["styled-components"] && (a(s.parent) || s.parent.type === "ArrowFunctionExpression" && a(s.parent.parent)))
          return;
        let e = r.getSourceCode(), n = (i) => i.reduce(
          (o, u) => {
            var S;
            if (u.type === "SpreadElement" || u.type === "RestElement")
              return o.push([]), o;
            let y = J(u, e), h = (S = o.at(-1)) == null ? void 0 : S.at(-1);
            t["partition-by-comment"] && y && pe(
              t["partition-by-comment"],
              y.value
            ) && o.push([]);
            let f, g = "ignore", m = [], { getGroup: w, setCustomGroups: E } = R(t.groups);
            u.key.type === "Identifier" ? { name: f } = u.key : u.key.type === "Literal" ? f = `${u.key.value}` : f = e.text.slice(...u.key.range);
            let b = {
              size: j(u.range),
              node: u,
              name: f
            };
            t["partition-by-new-line"] && h && B(e, h, b) && o.push([]), u.value.type === "AssignmentPattern" && ((G) => {
              G.right.type === "Identifier" && m.push(G.right.name);
              let ie = ($) => {
                let U = [];
                switch ($.type) {
                  case "ArrowFunctionExpression":
                    U.push($.body);
                    break;
                  case "ConditionalExpression":
                    U.push($.consequent, $.alternate);
                    break;
                  case "LogicalExpression":
                  case "BinaryExpression":
                    U.push($.left, $.right);
                    break;
                  case "CallExpression":
                    U.push(...$.arguments);
                    break;
                }
                U.forEach((z) => {
                  z.type === "Identifier" && m.push(z.name), (z.type === "BinaryExpression" || z.type === "ConditionalExpression") && ie(z);
                });
              };
              switch (G.right.type) {
                case "ArrowFunctionExpression":
                case "ConditionalExpression":
                case "LogicalExpression":
                case "BinaryExpression":
                case "CallExpression":
                  ie(G.right);
                  break;
              }
            })(u.value), E(t["custom-groups"], f);
            let N = {
              ...b,
              group: w(),
              dependencies: m,
              position: g
            };
            return o.at(-1).push(N), o;
          },
          [[]]
        );
        for (let i of n(s.properties))
          P(i, (o, u) => {
            let y = x(t.groups, o), h = x(t.groups, u);
            if (y > h || y === h && k(O(o, u, t))) {
              let f = (g) => {
                let m = {};
                for (let E of i) {
                  let b = x(t.groups, E);
                  b in m ? m[b] = A(
                    [...m[b], E],
                    t
                  ) : m[b] = [E];
                }
                let w = [];
                for (let E of Object.keys(m).sort())
                  w.push(...A(m[E], t));
                return T(g, i, w, e, {
                  partitionComment: t["partition-by-comment"]
                });
              };
              r.report({
                messageId: "unexpectedObjectsOrder",
                data: {
                  left: v(o.name),
                  right: v(u.name)
                },
                node: u.node,
                fix: f
              });
            }
          });
      }
    };
    return {
      ObjectExpression: l,
      ObjectPattern: l
    };
  }
}), ne = "sort-classes", Ie = I({
  name: ne,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted classes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          groups: {
            type: "array",
            default: []
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedClassesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    ClassBody: (l) => {
      if (l.body.length > 1) {
        let s = C(r.options.at(0), {
          type: p.alphabetical,
          order: d.asc,
          "ignore-case": !1,
          groups: ["property", "constructor", "method", "unknown"]
        }), t = r.getSourceCode(), c = l.body.map((a) => {
          var u;
          let e, { getGroup: n, defineGroup: i } = R(s.groups);
          a.type === "StaticBlock" ? e = "static" : a.type === "TSIndexSignature" ? e = t.text.slice(
            a.range.at(0),
            ((u = a.typeAnnotation) == null ? void 0 : u.range.at(0)) ?? a.range.at(1)
          ) : a.key.type === "Identifier" ? { name: e } = a.key : e = t.text.slice(...a.key.range);
          let o = e.startsWith("_") || e.startsWith("#");
          if (a.type === "MethodDefinition") {
            a.kind === "constructor" && i("constructor");
            let y = a.accessibility === "private" || o, h = a.static;
            y && h && i("static-private-method"), y && i("private-method"), h && i("static-method"), a.kind === "get" && i("get-method"), a.kind === "set" && i("set-method"), i("method");
          } else
            a.type === "TSIndexSignature" ? i("index-signature") : a.type === "PropertyDefinition" && ((a.accessibility === "private" || o) && i("private-property"), a.static && i("static-property"), i("property"));
          return {
            size: j(a.range),
            group: n(),
            node: a,
            name: e
          };
        });
        P(c, (a, e) => {
          let n = x(s.groups, a), i = x(s.groups, e);
          a.name !== e.name && (n > i || n === i && k(O(a, e, s))) && r.report({
            messageId: "unexpectedClassesOrder",
            data: {
              left: v(a.name),
              right: v(e.name)
            },
            node: e.node,
            fix: (o) => {
              let u = [], y = c.reduce(
                (f, g) => {
                  let m = x(s.groups, g);
                  return m in f ? f[m] = A(
                    [...f[m], g],
                    s
                  ) : f[m] = [g], f;
                },
                {}
              ), h = Object.keys(y).sort().reduce(
                (f, g) => [
                  ...f,
                  ...y[g]
                ],
                []
              );
              for (let f = 0, g = h.length; f < g; f++)
                u.push(
                  o.replaceTextRange(
                    M(c.at(f).node, t),
                    t.text.slice(
                      ...M(h.at(f).node, t)
                    )
                  )
                );
              return u;
            }
          });
        });
      }
    }
  })
}), oe = "sort-enums", je = I({
  name: oe,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted TypeScript enums"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedEnumsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    TSEnumDeclaration: (l) => {
      if (l.members.length > 1 && l.members.every(({ initializer: s }) => s)) {
        let s = C(r.options.at(0), {
          type: p.alphabetical,
          order: d.asc,
          "ignore-case": !1
        }), t = r.getSourceCode(), c = l.members.map((a) => ({
          name: a.id.type === "Literal" ? `${a.id.value}` : `${t.text.slice(...a.id.range)}`,
          size: j(a.range),
          node: a
        }));
        P(c, (a, e) => {
          k(O(a, e, s)) && r.report({
            messageId: "unexpectedEnumsOrder",
            data: {
              left: v(a.name),
              right: v(e.name)
            },
            node: e.node,
            fix: (n) => T(n, c, A(c, s), t)
          });
        });
      }
    }
  })
}), le = "sort-maps", ke = I({
  name: le,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Map elements"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [d.asc, d.desc],
            default: d.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedMapElementsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: d.asc
    }
  ],
  create: (r) => ({
    NewExpression: (l) => {
      if (l.callee.type === "Identifier" && l.callee.name === "Map" && l.arguments.length && l.arguments[0].type === "ArrayExpression") {
        let [{ elements: s }] = l.arguments;
        if (s.length > 1) {
          let t = C(r.options.at(0), {
            type: p.alphabetical,
            "ignore-case": !1,
            order: d.asc
          }), c = r.getSourceCode(), a = s.reduce(
            (e, n) => (n === null || n.type === "SpreadElement" ? e.push([]) : e.at(-1).push(n), e),
            [[]]
          );
          for (let e of a) {
            let n = e.map((i) => {
              let o;
              if (i.type === "ArrayExpression") {
                let [u] = i.elements;
                u ? u.type === "Literal" ? o = u.raw : o = c.text.slice(...u.range) : o = `${u}`;
              } else
                o = c.text.slice(...i.range);
              return {
                size: j(i.range),
                node: i,
                name: o
              };
            });
            P(n, (i, o) => {
              k(O(i, o, t)) && r.report({
                messageId: "unexpectedMapElementsOrder",
                data: {
                  left: v(i.name),
                  right: v(o.name)
                },
                node: o.node,
                fix: (u) => T(u, n, A(n, t), c)
              });
            });
          }
        }
      }
    }
  })
}), Ce = "eslint-plugin-perfectionist";
let V = (r) => {
  let l = {
    [se]: [
      "error",
      {
        groups: [
          "type",
          ["builtin", "external"],
          "internal-type",
          "internal",
          ["parent-type", "sibling-type", "index-type"],
          ["parent", "sibling", "index"],
          "object",
          "unknown"
        ],
        "custom-groups": {
          value: {},
          type: {}
        },
        "newlines-between": "always",
        "internal-pattern": ["~/**"]
      }
    ],
    [ne]: [
      "error",
      {
        groups: [
          "index-signature",
          "static-property",
          "private-property",
          "property",
          "constructor",
          "static-method",
          "private-method",
          "method",
          ["get-method", "set-method"],
          "unknown"
        ]
      }
    ],
    [ae]: [
      "error",
      {
        "partition-by-comment": !1
      }
    ],
    [K]: [
      "error",
      {
        "spread-last": !0
      }
    ],
    [X]: ["error"],
    [q]: ["error"],
    [F]: ["error"],
    [H]: ["error"],
    [Q]: ["error"],
    [Y]: ["error"],
    [Z]: ["error"],
    [ee]: ["error"],
    [te]: ["error"],
    [re]: ["error"],
    [oe]: ["error"],
    [le]: ["error"]
  };
  return {
    rules: Object.fromEntries(
      Object.entries(l).map(([s, [t, c = {}]]) => [
        `perfectionist/${s}`,
        [t, Object.assign(c, r)]
      ])
    ),
    plugins: ["perfectionist"]
  };
};
const Re = {
  rules: {
    [K]: me,
    [q]: ye,
    [ne]: Ie,
    [oe]: je,
    [re]: Ne,
    [se]: Oe,
    [ee]: we,
    [te]: Ae,
    [le]: ke,
    [H]: be,
    [Q]: xe,
    [Y]: Ee,
    [ae]: ve,
    [X]: ge,
    [Z]: Se,
    [F]: he
  },
  configs: {
    "recommended-alphabetical": V({
      type: p.alphabetical,
      order: d.asc,
      "ignore-case": !1
    }),
    "recommended-natural": V({
      type: p.natural,
      order: d.asc,
      "ignore-case": !1
    }),
    "recommended-line-length": V({
      type: p["line-length"],
      order: d.desc
    })
  },
  name: Ce
};
export {
  Re as default
};
